-- author: rafftnix
-- date: 02.12.2016

-- particles for the silage distributor

SilageDistributorParticles = {}

function SilageDistributorParticles.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(TurnOnVehicle, specializations);
end;

function SilageDistributorParticles:load(savegame)
	self.distributorGroundReference = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.distributorGroundReference#index"));
	self.distributorGroundReferenceThreshold = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.distributorGroundReference#threshold"), 0);
	
	self.distributorParticleSystem = {}
	local ps = Utils.loadParticleSystem(self.xmlFile, self.distributorParticleSystem, "vehicle.distributorParticleSystem", self.components, false, nil, self.baseDirectory);
end;

function SilageDistributorParticles:delete()
	Utils.deleteParticleSystem(self.distributorParticleSystem);
end;

function SilageDistributorParticles:mouseEvent(posX, posY, isDown, isUp, button)
end;

function SilageDistributorParticles:keyEvent(unicode, sym, modifier, isDown)
end;

function SilageDistributorParticles:update(dt)
	local particlesActive = false;
	if self:getIsTurnedOn() then
		local x, y, z = getWorldTranslation(self.distributorGroundReference);
        local densityHeight = TipUtil.getHeightAtWorldPos(x, y, z);
		if densityHeight > (y + self.distributorGroundReferenceThreshold) then
			particlesActive = true;
		end;
	end;
	Utils.setEmittingState(self.distributorParticleSystem, particlesActive);
end;

function SilageDistributorParticles:updateTick(dt)
end;

function SilageDistributorParticles:draw()
end;