UnlockCompJointEvent = {};
UnlockCompJointEvent_mt = Class(UnlockCompJointEvent, Event);
InitEventClass(UnlockCompJointEvent, "UnlockCompJointEvent");

function UnlockCompJointEvent:emptyNew()
    local self = Event:new(UnlockCompJointEvent_mt);
    self.className = "UnlockCompJointEvent";
    return self;
end;

function UnlockCompJointEvent:new(vehicle, isUnlocked)
    local self = UnlockCompJointEvent:emptyNew();
	self.vehicle = vehicle;
	self.isUnlocked = isUnlocked;
    return self;
end;

function UnlockCompJointEvent:writeStream(streamId, connection)
	writeNetworkNodeObject(streamId, self.vehicle);
	streamWriteBool(streamId, self.isUnlocked);
end;

function UnlockCompJointEvent:readStream(streamId, connection)
	self.vehicle = readNetworkNodeObject(streamId);
	self.isUnlocked = streamReadBool(streamId);
	self:run(connection);
end;

function UnlockCompJointEvent:run(connection)
	self.vehicle:setIsCompJointUnlocked(self.isUnlocked, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(UnlockCompJointEvent:new(self.vehicle, self.isUnlocked), nil, connection, self.vehicle);
	end;
end;

function UnlockCompJointEvent.sendEvent(vehicle, isUnlocked, noEventSend)
	if not noEventSend then
		if g_server ~= nil then
			g_server:broadcastEvent(UnlockCompJointEvent:new(vehicle, isUnlocked), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(UnlockCompJointEvent:new(vehicle, isUnlocked));
		end;
	end;
end;